import { AnyAction } from 'redux';
import { ThunkAction } from 'redux-thunk';
declare type IScriptSrcFunction = (callbackName: string) => string;
export declare type IScriptSrc = string | IScriptSrcFunction;
/**
 *
 * @param src
 * @param callbackName
 */
export declare function _loadScript(src: string, callbackName: string | null): {
    type: string;
    src: string;
    callbackName: string | null;
};
/**
 * Loads the given script and returns a Promise which resolves upon its completion
 * @param src
 * @param callbackName
 */
export declare function loadScript<S = {}>(src: IScriptSrc, callbackName?: string | null): ThunkAction<Promise<void>, S, undefined, AnyAction>;
/**
 * Creates an action which indicates that the given script has loaded
 * @param src
 */
export declare function scriptLoaded(src: string): {
    type: string;
    src: string;
};
export {};
