"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports._loadScript = _loadScript;
exports.loadScript = loadScript;
exports.scriptLoaded = scriptLoaded;

var _isFunction2 = _interopRequireDefault(require("lodash/isFunction"));

var _sha = _interopRequireDefault(require("sha256"));

var _listeners = require("./listeners");

var _constants = require("./constants");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 *
 * @param src
 * @param callbackName
 */
function _loadScript(src, callbackName) {
  return {
    type: _constants.LOAD_SCRIPT,
    src,
    callbackName
  };
}
/**
 * Loads the given script and returns a Promise which resolves upon its completion
 * @param src
 * @param callbackName
 */


function loadScript(src, callbackName = null) {
  return dispatch => new Promise(resolve => {
    const isCustomCallbackName = (0, _isFunction2.default)(src);

    const _callbackName = callbackName || isCustomCallbackName && `${_constants.CALLBACKS_NAMESPACE}${(0, _sha.default)(src(''))}`.substr(0, 16) || null;

    const _src = isCustomCallbackName ? src(_callbackName) : src;

    (0, _listeners.register)(_src, resolve);
    dispatch(_loadScript(_src, _callbackName));
  });
}
/**
 * Creates an action which indicates that the given script has loaded
 * @param src
 */


function scriptLoaded(src) {
  return {
    type: _constants.SCRIPT_LOADED,
    src
  };
}
//# sourceMappingURL=actions.js.map