"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.register = register;
exports.notify = notify;

var _includes2 = _interopRequireDefault(require("lodash/includes"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const listeners = {};
const loaded = [];
/**
 * For a given script, fires all listeners and removes them from the list
 * @param src
 */

function fire(src) {
  let listener; // eslint-disable-next-line no-cond-assign

  while (listener = listeners[src].pop()) {
    listener();
  }
}
/**
 * Adds a callback for the given script to be called when the script has been loaded (or immediately calls if the
 * script has already been loaded)
 * @param src
 * @param callback
 */


function register(src, callback) {
  if ((0, _includes2.default)(loaded, src)) {
    callback();
    return;
  }

  listeners[src] = listeners[src] || [];
  listeners[src].push(callback);
}
/**
 * Adds the script to the list of loaded scripts and notifies the listeners
 * @param src
 */


function notify(src) {
  loaded.push(src);
  fire(src);
}
//# sourceMappingURL=listeners.js.map