"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = reducer;
exports.initialState = void 0;

var _uniq2 = _interopRequireDefault(require("lodash/uniq"));

var _constants = require("./constants");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const initialState = {
  loading: [],
  loaded: [],
  callbacks: {}
};
/**
 * Redux Scripts Manager Reducer
 * @param state
 * @param action
 */

exports.initialState = initialState;

function reducer(state = initialState, action) {
  switch (action.type) {
    case _constants.LOAD_SCRIPT:
      return { ...state,
        loading: (0, _uniq2.default)([...state.loading, action.src]),
        callbacks: { ...state.callbacks,
          [action.src]: action.callbackName
        }
      };

    case _constants.SCRIPT_LOADED:
      return { ...state,
        loaded: (0, _uniq2.default)([...state.loaded, action.src]),
        callbacks: { ...state.callbacks,
          [action.src]: undefined
        }
      };

    default:
      return state;
  }
}
//# sourceMappingURL=reducer.js.map